using System;
using System.Data;
using System.Data.OleDb;
using System.Web.Caching;
namespace StatMentorNET
{
	/// <summary>
	/// Summary description for MyDatabase.
	/// </summary>
	public class MyDatabase
	{
		public MyDatabase()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public bool ShouldLogReferer( System.Web.UI.Page pg, string sPage )
		{
			DataView m_DV;
			Cache myCache = System.Web.HttpRuntime.Cache;
			m_DV = (DataView)myCache["sitestoignore"];
			if (m_DV == null )
			{
				OleDbConnection Conn = new OleDbConnection(GetConnectionString() );
				Conn.Open();
				OleDbDataAdapter oAdapter = new OleDbDataAdapter("select * from sitestoignore", Conn);

				DataSet ds = new DataSet();
				oAdapter.Fill(ds, "sitestoignore");

				m_DV = new DataView(ds.Tables["sitestoignore"]);
				myCache["sitestoignore"] = m_DV;
			}
			for ( int i = 0; i < m_DV.Table.Rows.Count; i++ )
			{
				DataRow dr = m_DV.Table.Rows[i];
				string strSite = (string)dr["site"];
				if ( sPage.Length >= strSite.Length )
				{
					string strPageBegin = sPage.Substring(0,strSite.Length);
					strPageBegin = strPageBegin.ToUpper();
					strSite = strSite.ToUpper();
					if ( strSite.CompareTo(strPageBegin) == 0 )
						return false;
				}
			}

			return true;
		}
		public void LogVisit()
		{
			System.Data.OleDb.OleDbConnection Conn = new System.Data.OleDb.OleDbConnection(GetConnectionString() );
			Conn.Open();
			OleDbCommand oCommand = Conn.CreateCommand();
			oCommand.CommandText = "select count(*) from visitor where datum=?";
			oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
			int lCount = (int)oCommand.ExecuteScalar();

			oCommand = Conn.CreateCommand();
			if ( lCount == 0 )
			{
				oCommand.CommandText = "insert into visitor(datum,antal) values(?,?)";
				oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
				oCommand.Parameters.Add("@antal", System.Data.OleDb.OleDbType.Integer).Value=1;
			}
			else
			{
				oCommand.CommandText = "update visitor set antal=antal+1 where datum = ?";
				oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
			}
			oCommand.ExecuteNonQuery();
			Conn.Close();
		}
		public System.Data.IDataReader GetReferer( string sStart, string sEnd )
		{
			System.Data.OleDb.OleDbConnection Conn = new System.Data.OleDb.OleDbConnection(GetConnectionString() );
			Conn.Open();
			System.Data.OleDb.OleDbDataReader oDataReader;
			OleDbCommand oCommand = Conn.CreateCommand();
			oCommand.CommandText = "select max(fldAuto) as fldAuto,page,sum(antal) as antal from referer where datum>=? and datum <=? group by page order by page";
			oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=sStart;
			oCommand.Parameters.Add("@datum2", System.Data.OleDb.OleDbType.VarChar,10).Value=sEnd;

			oDataReader = oCommand.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
			return oDataReader;
		}
		public System.Data.IDataReader GetVisitors( string sStart, string sEnd )
		{
			System.Data.OleDb.OleDbConnection Conn = new System.Data.OleDb.OleDbConnection(GetConnectionString() );
			Conn.Open();
			System.Data.OleDb.OleDbDataReader oDataReader;
			OleDbCommand oCommand = Conn.CreateCommand();
			oCommand.CommandText = "select max(fldAuto) as fldAuto,datum,sum(antal) as visitors from visitor where datum>=? and datum <=? group by datum order by datum";
			oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=sStart;
			oCommand.Parameters.Add("@datum2", System.Data.OleDb.OleDbType.VarChar,10).Value=sEnd;

			oDataReader = oCommand.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
			return oDataReader;
		}
		public System.Data.IDataReader GetPvPerDate( string sStart, string sEnd )
		{
			System.Data.OleDb.OleDbConnection Conn = new System.Data.OleDb.OleDbConnection(GetConnectionString() );
			Conn.Open();
			System.Data.OleDb.OleDbDataReader oDataReader;
			OleDbCommand oCommand = Conn.CreateCommand();
			oCommand.CommandText = "select max(fldAuto) as fldAuto,datum,sum(antal) as pageviews from pageview where datum>=? and datum <=? group by datum order by datum";
			oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=sStart;
			oCommand.Parameters.Add("@datum2", System.Data.OleDb.OleDbType.VarChar,10).Value=sEnd;

			oDataReader = oCommand.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
			return oDataReader;
		}		public System.Data.IDataReader GetPvPerPage( string sStart, string sEnd )
		{
			System.Data.OleDb.OleDbConnection Conn = new System.Data.OleDb.OleDbConnection(GetConnectionString() );
			Conn.Open();
			System.Data.OleDb.OleDbDataReader oDataReader;
			OleDbCommand oCommand = Conn.CreateCommand();
			oCommand.CommandText = "select max(fldAuto) as fldAuto,page,sum(antal) as pageviews from pageview where datum>=? and datum <=? group by page order by page";
			oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=sStart;
			oCommand.Parameters.Add("@datum2", System.Data.OleDb.OleDbType.VarChar,10).Value=sEnd;

			oDataReader = oCommand.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
			return oDataReader;
		}
		public void LogReferer( string sPage )
		{
			System.Data.OleDb.OleDbConnection Conn = new System.Data.OleDb.OleDbConnection(GetConnectionString() );
			Conn.Open();
			OleDbCommand oCommand = Conn.CreateCommand();
			oCommand.CommandText = "select count(*) from referer where datum=? and page=?";
			oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
			oCommand.Parameters.Add("@page", System.Data.OleDb.OleDbType.VarChar,255).Value=sPage;
			int lCount = (int)oCommand.ExecuteScalar();
			oCommand = Conn.CreateCommand();
			if ( lCount == 0 )
			{
				oCommand.CommandText = "insert into referer(datum,page,antal) values(?,?,?)";
				oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
				oCommand.Parameters.Add("@page", System.Data.OleDb.OleDbType.VarChar,255).Value=sPage;
				oCommand.Parameters.Add("@antal", System.Data.OleDb.OleDbType.Integer).Value=(long)1;
			}
			else
			{
				oCommand.CommandText = "update referer set antal=antal+1 where datum = ? and page=?";
				oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
				oCommand.Parameters.Add("@page", System.Data.OleDb.OleDbType.VarChar,255).Value=sPage;
			}
			oCommand.ExecuteNonQuery();
			Conn.Close();
		}
		public void LogPageView( string sPage )
		{
			System.Data.OleDb.OleDbConnection Conn = new System.Data.OleDb.OleDbConnection(GetConnectionString() );
			Conn.Open();
			OleDbCommand oCommand = Conn.CreateCommand();
			oCommand.CommandText = "select count(*) from pageview where datum=? and page=?";
			oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
			oCommand.Parameters.Add("@page", System.Data.OleDb.OleDbType.VarChar,255).Value=sPage;
			int lCount = (int)oCommand.ExecuteScalar();
			oCommand = Conn.CreateCommand();
			if ( lCount == 0 )
			{
				oCommand.CommandText = "insert into pageview(datum,page,antal) values(?,?,?)";
				oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
				oCommand.Parameters.Add("@page", System.Data.OleDb.OleDbType.VarChar,255).Value=sPage;
				oCommand.Parameters.Add("@antal", System.Data.OleDb.OleDbType.Integer).Value=1;
			}
			else
			{
				oCommand.CommandText = "update pageview set antal=antal+1 where datum = ? and page=?";
				oCommand.Parameters.Add("@datum", System.Data.OleDb.OleDbType.VarChar,10).Value=System.DateTime.Now.ToString("yyyy-MM-dd");
				oCommand.Parameters.Add("@page", System.Data.OleDb.OleDbType.VarChar,255).Value=sPage;
			}
			oCommand.ExecuteNonQuery();
			Conn.Close();
		}
		public string GetConnectionString()
		{
			return System.Configuration.ConfigurationSettings.AppSettings["StatMentorConnString"];
		}
	}
}
