using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace StatMentorNET
{
	/// <summary>
	/// Summary description for admin.
	/// </summary>
	public class admin : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblHeader;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.DropDownList ddlYearStart;
		protected System.Web.UI.WebControls.DropDownList ddlMonthStart;
		protected System.Web.UI.WebControls.DropDownList ddlDayStart;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.DropDownList ddlYearEnd;
		protected System.Web.UI.WebControls.DropDownList ddlMonthEnd;
		protected System.Web.UI.WebControls.DropDownList ddlDayEnd;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.ListBox lbReport;
		protected System.Web.UI.WebControls.Button btnStartEnd;
		protected System.Web.UI.WebControls.PlaceHolder m_Content;
		private ArrayList  m_ReportArray;
		private ArrayList  m_YearArray;
		private ArrayList  m_DayArray;
		private ArrayList  m_MonthArray;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.Button btnIgnore;
		private int m_lStartYear = 2002;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if ( Session["login"] == null )
				Response.Redirect("adminlogin.aspx");
			if ( !IsPostBack )
			{
				DateTime dtNow = DateTime.Now;
				dtNow = dtNow.AddDays(-7);
				string strStartDate = dtNow.ToString("yyyy-MM-dd"); 
				dtNow = dtNow.AddDays(7);
				string strEndDate = dtNow.ToString("yyyy-MM-dd"); 
				ViewState["startdate"] = strStartDate;
				ViewState["enddate"] = strEndDate;
				lblHeader.Text = "StatMentor";
				DataBind();
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnStartEnd.Click += new System.EventHandler(this.btnStartEnd_Click);
			this.lbReport.SelectedIndexChanged += new System.EventHandler(this.lbReport_SelectedIndexChanged);
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.btnIgnore.Click += new System.EventHandler(this.btnIgnore_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		int GetMonthIndex( string strName )
		{
			GetMonths();
			for ( int i = 0; i < 12; i++ )
			{
				string strName2 = ( string )m_MonthArray[i];
				if ( strName2 == strName )
					return i;
			}
			return 0;
		}

		private void btnStartEnd_Click(object sender, System.EventArgs e)
		{
			//We have changed date... First check if it's ok???
			string strEnd = ddlYearEnd.SelectedItem.Value + "-";
			int nMonth = GetMonthIndex(ddlMonthEnd.SelectedItem.Value);
			nMonth++;
			if ( nMonth<10 )
				strEnd += "0";
			strEnd += nMonth.ToString() + "-";
			if ( ddlDayEnd.SelectedItem.Value.Length == 1 )
				strEnd += "0";
			strEnd += ddlDayEnd.SelectedItem.Value;

			string strStart = ddlYearStart.SelectedItem.Value + "-";
			nMonth = GetMonthIndex(ddlMonthStart.SelectedItem.Value);
			nMonth++;
			if ( nMonth<10 )
				strStart += "0";
			strStart += nMonth.ToString() + "-";
			if ( ddlDayStart.SelectedItem.Value.Length == 1 )
				strStart += "0";
			strStart += ddlDayStart.SelectedItem.Value;
			if ( strEnd.CompareTo(strStart)<0 )
				lblHeader.Text = "Error setting date. Resetting";
			else
			{
				ViewState["startdate"] = strStart;
				ViewState["enddate"] = strEnd;
				
				if ( lbReport.SelectedIndex < 0 )
				{
					lblHeader.Text = "Select a report to the left";
					return;
				}
				CreateReport((string)lbReport.SelectedItem.Value);
			}
		}

		public int GetDay( string strStartOrEnd )
		{
			string strTemp;
			if ( strStartOrEnd == "start" )
				strTemp = (string)ViewState["startdate"];
			else
				strTemp = (string)ViewState["enddate"];
			strTemp = strTemp.Substring(8,2);
			return Convert.ToInt16(strTemp)-1;
		}
		public int GetMonth( string strStartOrEnd )
		{
			string strTemp;
			if ( strStartOrEnd == "start" )
				strTemp = (string)ViewState["startdate"];
			else
				strTemp = (string)ViewState["enddate"];
			strTemp = strTemp.Substring(5,2);
			return Convert.ToInt16(strTemp)-1;
		}
		public int GetYear( string strStartOrEnd )
		{
			string strTemp;
			if ( strStartOrEnd == "start" )
				strTemp = (string)ViewState["startdate"];
			else
				strTemp = (string)ViewState["enddate"];
			strTemp = strTemp.Substring(0,4);
			return Convert.ToInt16(strTemp)-m_lStartYear;
		}

		public System.Collections.ICollection GetDays()
		{
			if (m_DayArray == null ) 
			{
				m_DayArray = new ArrayList();
				for ( int i = 1; i < 32; i++ )
					m_DayArray.Add( i.ToString() );
			}
			return m_DayArray;
		}
		public System.Collections.ICollection GetYears()
		{
			if (m_YearArray == null ) 
			{
				m_YearArray = new ArrayList();
				for ( int i = m_lStartYear; i < m_lStartYear+3; i++ )
					m_YearArray.Add( i.ToString() );
			}
			return m_YearArray;
		}

		public System.Collections.ICollection GetMonths()
		{
			if (m_MonthArray == null ) 
			{
				m_MonthArray = new ArrayList();
				m_MonthArray.Add("January");
				m_MonthArray.Add("February");
				m_MonthArray.Add("March");
				m_MonthArray.Add("April");
				m_MonthArray.Add("May");
				m_MonthArray.Add("June");
				m_MonthArray.Add("July");
				m_MonthArray.Add("August");
				m_MonthArray.Add("September");
				m_MonthArray.Add("October");
				m_MonthArray.Add("November");
				m_MonthArray.Add("December");
			}
			return m_MonthArray;
		}

		public System.Collections.ICollection GetReports()
		{
			if (m_ReportArray == null ) 
			{
				m_ReportArray = new ArrayList();
				m_ReportArray.Add("Visitors");
				m_ReportArray.Add("Pageviews per page");
				m_ReportArray.Add("Pageviews per date");
				m_ReportArray.Add("Referers");
			}
			return m_ReportArray;
		}
		private void CreateReport( string sRep )
		{
			//m_Content.Controls.Clear();
			lblHeader.Text = sRep;
			switch(sRep)
			{
				case "Visitors":
				{
					ucvisitors report = (ucvisitors) LoadControl("ucvisitors.ascx");
					report.StartString = (string) ViewState["startdate"];
					report.EndString = (string) ViewState["enddate"];
					m_Content.Controls.Add(report);
				}
					break;
				case "Pageviews per page":
				{
					ucpvperpage report = (ucpvperpage) LoadControl("ucpvperpage.ascx");
					report.StartString = (string) ViewState["startdate"];
					report.EndString = (string) ViewState["enddate"];
					m_Content.Controls.Add(report);
				}
					break;
				case "Pageviews per date":
				{
					ucpvperdate report = (ucpvperdate) LoadControl("ucpvperdate.ascx");
					report.StartString = (string) ViewState["startdate"];
					report.EndString = (string) ViewState["enddate"];
					m_Content.Controls.Add(report);
				}
					break;
				case "Referers":
				{
					ucreferer report = (ucreferer) LoadControl("ucreferer.ascx");
					report.StartString = (string) ViewState["startdate"];
					report.EndString = (string) ViewState["enddate"];
					m_Content.Controls.Add(report);
				}
					break;
			}
		}
		private void lbReport_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ListBox lb = (ListBox )sender;
			if ( lb.SelectedIndex >= 0 )
			{
				CreateReport((string)lb.SelectedItem.Value);
			}
		}

		private void Button1_Click(object sender, System.EventArgs e)
		{
			lblHeader.Text = "Generate HTML";
			ucgethtml report = (ucgethtml) LoadControl("ucgethtml.ascx");
			m_Content.Controls.Add(report);
		}

		private void btnIgnore_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("adminignore.aspx");
			Response.End();
		}
	}
}
